
/****************************************************************************
 * An interface to be implemented by anything interested in changes to
 * property constraints
 *
 * @author Jussi Stader
 * @version 3.1
 * Updated: Mon Jul 17 15:11:25 2006
 * Copyright: (c) 2006, AIAI, University of Edinburgh
 *
 *****************************************************************************
 */

package ix.iview;

import java.util.*;

import ix.util.lisp.*;
import ix.iview.domain.*;



/****************************************************************************
 * An interface to be implemented by anything interested in changes to
 * property constraints
 */
public interface PropertyConstraintsListener {
  public void variableConstraintsChanged(ItemVar variable, HashMap propConsts);
  public void variableNameChanged(ItemVar oldVar, ItemVar newVar);
  public void variableTypeChanged(ItemVar var, UIObjectClass oldType, 
				  UIObjectClass newType);
}
