;;; Tests what happens when a refinement can satisfy more than
;;; one condition.

;;; /\/: The test will be better when we can force the jupiter
;;; refinement to be used at most once.  Indeed, do that for
;;; all of the refinements, so that there are only 2 possible plans.

(refinement test1 (test1)
  (variables ?x)
  (constraints
    (world-state condition (has-stripes ?x) = true)
    (world-state condition (has-moons ?x) = true)
    (world-state condition (has-red-spot ?x) = true)))

(refinement jupiter (jupiter)
  (constraints
    (world-state effect (has-moons jupiter) = true)
    (world-state effect (has-stripes jupiter) = true)
    (world-state effect (has-red-spot jupiter) = true)))

(refinement jupiters-moons (moons jupiter)
  (constraints
    (world-state effect (has-moons jupiter) = true)))

(refinement jupiters-stripes (stripes jupiter)
  (constraints
    (world-state effect (has-stripes jupiter) = true)))

(refinement jupiters-red-spot (red-spot jupiter)
  (constraints
    (world-state effect (has-red-spot jupiter) = true)))

;;; End
